/*
Core

Core API is used to manage resources around organisation like auth, set webhooks per channels, manage campaigns.

API version: 1.0
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package coreapi

import (
	"encoding/json"
)

// checks if the ExternalIntegrations type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &ExternalIntegrations{}

// ExternalIntegrations struct for ExternalIntegrations
type ExternalIntegrations struct {
	Unzer *ExternalIntegrationsUnzer `json:"unzer,omitempty"`
}

// NewExternalIntegrations instantiates a new ExternalIntegrations object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewExternalIntegrations() *ExternalIntegrations {
	this := ExternalIntegrations{}
	return &this
}

// NewExternalIntegrationsWithDefaults instantiates a new ExternalIntegrations object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewExternalIntegrationsWithDefaults() *ExternalIntegrations {
	this := ExternalIntegrations{}
	return &this
}

// GetUnzer returns the Unzer field value if set, zero value otherwise.
func (o *ExternalIntegrations) GetUnzer() ExternalIntegrationsUnzer {
	if o == nil || IsNil(o.Unzer) {
		var ret ExternalIntegrationsUnzer
		return ret
	}
	return *o.Unzer
}

// GetUnzerOk returns a tuple with the Unzer field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *ExternalIntegrations) GetUnzerOk() (*ExternalIntegrationsUnzer, bool) {
	if o == nil || IsNil(o.Unzer) {
		return nil, false
	}
	return o.Unzer, true
}

// HasUnzer returns a boolean if a field has been set.
func (o *ExternalIntegrations) HasUnzer() bool {
	if o != nil && !IsNil(o.Unzer) {
		return true
	}

	return false
}

// SetUnzer gets a reference to the given ExternalIntegrationsUnzer and assigns it to the Unzer field.
func (o *ExternalIntegrations) SetUnzer(v ExternalIntegrationsUnzer) {
	o.Unzer = &v
}

func (o ExternalIntegrations) MarshalJSON() ([]byte, error) {
	toSerialize,err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o ExternalIntegrations) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.Unzer) {
		toSerialize["unzer"] = o.Unzer
	}
	return toSerialize, nil
}

type NullableExternalIntegrations struct {
	value *ExternalIntegrations
	isSet bool
}

func (v NullableExternalIntegrations) Get() *ExternalIntegrations {
	return v.value
}

func (v *NullableExternalIntegrations) Set(val *ExternalIntegrations) {
	v.value = val
	v.isSet = true
}

func (v NullableExternalIntegrations) IsSet() bool {
	return v.isSet
}

func (v *NullableExternalIntegrations) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableExternalIntegrations(val *ExternalIntegrations) *NullableExternalIntegrations {
	return &NullableExternalIntegrations{value: val, isSet: true}
}

func (v NullableExternalIntegrations) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableExternalIntegrations) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}


